/*
 * Use at your own risk.
 *
 * Copyright (C) 2005-2008 Sourcefire, Inc.
 * 
 * This file is autogenerated via rules2c, by Brian Caswell <bmc@sourcefire.com>
 * 
 * Does not use the built-in detection function.
 *
 * alert tcp $EXTERNAL_NET $HTTP_PORTS -> $HOME_NET any (msg:"EXPLOIT Apple Quicktime crgn atom parsing stack buffer overflow attempt"; flow:to_client,established; flowbits:isset,file.quicktime;  content:"crgn"; reference:bugtraq,28583; reference:CVE,2008-1017; classtype:attempted-user; sid:1;)
 */




#include "sf_snort_plugin_api.h"
#include "sf_snort_packet.h"

//#define DEBUG
#ifdef DEBUG
#define DEBUG_WRAP(code) code
#else
#define DEBUG_WRAP(code)
#endif

/* declare detection functions */
int rule13897eval(void *p);

/* declare rule data structures */
/* precompile the stuff that needs pre-compiled */
/* flow:established, to_client; */
static FlowFlags rule13897flow0 = 
{
    FLOW_ESTABLISHED|FLOW_TO_CLIENT
};

static RuleOption rule13897option0 =
{
    OPTION_TYPE_FLOWFLAGS,
    {
        &rule13897flow0
    }
};
/* flowbits:isset "file.quicktime"; */
static FlowBitsInfo rule13897flowbits1 =
{
    "file.quicktime",
    FLOWBIT_ISSET,
    0,
};

static RuleOption rule13897option1 =
{
    OPTION_TYPE_FLOWBIT,
    {
        &rule13897flowbits1
    }
};
// content:"crgn"; 
static ContentInfo rule13897content2 = 
{
    (u_int8_t *) "crgn", /* pattern (now in snort content format) */
    0, /* depth */
    0, /* offset */
    CONTENT_BUF_NORMALIZED, /* flags */ // XXX - need to add CONTENT_FAST_PATTERN support
    NULL, /* holder for boyer/moore PTR */
    NULL, /* more holder info - byteform */
    0, /* byteform length */
    0 /* increment length*/
};

static RuleOption rule13897option2 = 
{
    OPTION_TYPE_CONTENT,
    {
        &rule13897content2
    }
};

/* references for sid 13897 */
/* reference: bugtraq "28583"; */
static RuleReference rule13897ref1 = 
{
    "bugtraq", /* type */
    "28583" /* value */
};

/* reference: cve "2008-1017"; */
static RuleReference rule13897ref2 = 
{
    "cve", /* type */
    "2008-1017" /* value */
};

static RuleReference *rule13897refs[] =
{
    &rule13897ref1,
    &rule13897ref2,
    NULL
};

/* metadata for sid 13897 */
/* metadata:service http, policy balanced-ips drop, policy security-ips drop; */
static RuleMetaData rule13897service1 = 
{
    "service http"
};


static RuleMetaData rule13897policy1 = 
{
    "policy balanced-ips drop"
};

static RuleMetaData rule13897policy2 = 
{
    "policy security-ips drop"
};


static RuleMetaData *rule13897metadata[] =
{
    &rule13897service1,
    &rule13897policy1,
    &rule13897policy2,
    NULL
};

RuleOption *rule13897options[] =
{
    &rule13897option0,
    &rule13897option1,
    &rule13897option2,
    NULL
};

Rule rule13897 = {
   
   /* rule header, akin to => tcp any any -> any any               */{
       IPPROTO_TCP, /* proto */
       "$EXTERNAL_NET", /* SRCIP     */
       "$HTTP_PORTS", /* SRCPORT   */
       0, /* DIRECTION */
       "$HOME_NET", /* DSTIP     */
       "any", /* DSTPORT   */
   },
   /* metadata */
   { 
       3,  /* genid (HARDCODED!!!) */
       13897, /* sigid */
       5, /* revision */
   
       "attempted-user", /* classification */
       0,  /* hardcoded priority XXX NOT PROVIDED BY GRAMMAR YET! */
       "EXPLOIT Apple Quicktime crgn atom parsing buffer overflow attempt",     /* message */
       rule13897refs /* ptr to references */
       ,rule13897metadata
   },
   rule13897options, /* ptr to rule options */
   &rule13897eval, /* use the built in detection function */
   0 /* am I initialized yet? */
};


/* detection functions */
int rule13897eval(void *p) {
   const u_int8_t *cursor_normal = 0;
   SFSnortPacket *sp = (SFSnortPacket *) p;

   const u_int8_t *beg_of_payload, *end_of_payload;
   u_int32_t atom_size;
   u_int16_t region_size;
      
   if(sp == NULL)
      return RULE_NOMATCH;

   if(sp->payload == NULL)
      return RULE_NOMATCH;
    
   // flow:established, to_client;
   if(checkFlow(p, rule13897options[0]->option_u.flowFlags) > 0 ) {
      // flowbits:isset "file.quicktime";
      if(processFlowbits(p, rule13897options[1]->option_u.flowBit) > 0) {
        // content:"crgn";
        if(contentMatch(p, rule13897options[2]->option_u.content, &cursor_normal) > 0) {
           if(getBuffer(sp, CONTENT_BUF_NORMALIZED, &beg_of_payload, &end_of_payload) <= 0)
              return RULE_NOMATCH;
                
           if(cursor_normal + 2 >= end_of_payload)
              return RULE_NOMATCH;
   
           region_size = (*cursor_normal++) << 8;
           region_size |= *cursor_normal++;
   
           DEBUG_WRAP(printf("REGION SIZE: %d\n", region_size));
      
           cursor_normal = cursor_normal - 10;

           if(cursor_normal < beg_of_payload)
              return RULE_NOMATCH;
      
           atom_size = (*cursor_normal++) << 24;   
           atom_size |= (*cursor_normal++) << 16;
           atom_size |= (*cursor_normal++) << 8;
           atom_size |= *cursor_normal++;
   
           DEBUG_WRAP(printf("ATOM SIZE: %d\n", atom_size));
  
           // Changed from region_size > (atom_size - 8) to avoid
           // integer underflow from (atom_size - 8)
           if(((u_int32_t)region_size + 8) > atom_size) 
              return RULE_MATCH;
         }
      }
   }

   return RULE_NOMATCH;
}

/*
Rule *rules[] = {
    &rule13897,
    NULL
};
*/

